﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="webAJAX1.aspx.vb" Inherits="webAJAX1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Probando UpdatePanel</title>
    <script runat="server" id="'">
        'Declaro una variable ListaPersonas de tipo Lista
        'que hereda la estructura de la clase Personas
        Private ListaPersonas As New List(Of Personas)
        'Protected Sub Page_Load()
        '    'Page.IsPostBack : obtiene un valor que indica si la página se está cargando como respuesta a un valor 
        '    'devuelto por el cliente,o si es la primera vez que se carga y se obtiene acceso a la misma. 
        '    'If Not Page.IsPostBack Then
        '    '    Que se cree una instancia Lista basado en la estructura de la clase Personas
        '    'ListaPersonas = New List(Of Personas)
        '    '    'Guarda el estado actual de ListaPersonas en el estado de vista Listado
        '    '    ViewState("Listado") = ListaPersonas
        '    'Else
        '    '    'Si se carga la página de nuevo cargar en la lista ListaPersonas
        '    '    'el contenido del estado de vista Listado
        '    '    ListaPersonas = CType(ViewState("Listado"), List(Of Personas))
        '    '    'Se carga el GridView PersonasGridView con los datos contenidos en ListaPersonas
        '    '    PersonasGridView.DataSource = ListaPersonas
        '    '    PersonasGridView.DataBind()
        '    'End If
        'End Sub
        
        Protected Sub limpiarCajasTexto()
            'Se limpian los TextBox
            txtCedula.Text = String.Empty
            txtNombre.Text = String.Empty
            txtApellidos.Text = String.Empty
            txtDireccion.Text = String.Empty
        End Sub
        
        Protected Sub btnEnlistar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnEnlistar.Click
            'Si el contenido del objeto txtCedula.Text es null o vacio... 
            If String.IsNullOrEmpty(txtCedula.Text) Then Return
            'HtmlEncode es un método del objeto Server que se utiliza para convertir un string codificado en HTML, 
            'haciéndolo ejecutable por los navegadores en código visible, es decir, es un tipo de código que aunque 
            'el navegador lo muestra como HTML en realidad es ASCII puro. Por ejemplo se podría escribir una 
            'instrucción tal como Server.HtmlEncode(“cadena”) y esa cadena se reemplazarían caracteres especiales 
            'de HTML como < por &lt o ¿ por &#191.  
            Dim Cedula As String = Server.HtmlEncode(txtCedula.Text)
            Dim Nombre As String = Server.HtmlEncode(txtNombre.Text)
            Dim Apellidos As String = Server.HtmlEncode(txtApellidos.Text)
            Dim Direccion As String = Server.HtmlEncode(txtDireccion.Text)

            'Se agrega un nuevo registro en ListaPersonas invocando al constructor de la clase Personas. 
            ListaPersonas.Add(New Personas(Cedula, Nombre, Apellidos, Direccion))
            PersonasGridView.DataSource = ListaPersonas
            '
            'ViewState("Listado") = ListaPersonas
            'Se actualiza PersonasGridView
            PersonasGridView.DataBind()
            'PersonasGridView.PageIndex = PersonasGridView.PageCount          
        End Sub
        
        Protected Sub btnCancelar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCancelar.Click
            limpiarCajasTexto()
        End Sub
        'Se serializa la clase personas
        'La serialización es el proceso de convertir el estado de un objeto a un formato que se pueda almacenar o transportar.
        <Serializable()> _
        Public Class Personas
            Private _cedula As String
            Private _nombre As String
            Private _apellidos As String
            Private _direccion As String
            Public ReadOnly Property Cedula() As String
                Get
                    Return _cedula
                End Get
            End Property
            Public ReadOnly Property Nombre() As String
                Get
                    Return _nombre
                End Get
            End Property
            Public ReadOnly Property Apellidos() As String
                Get
                    Return _apellidos
                End Get
            End Property
            Public ReadOnly Property direccion() As String
                Get
                    Return _direccion
                End Get
            End Property
            Sub New(ByVal ced$, ByVal nom$, ByVal ape$, ByVal dire$)
                _cedula = ced
                _nombre = nom
                _apellidos = ape
                _direccion = dire
            End Sub
        End Class
        'Se procede elaborando la hoja de estilos (CSS)
    </script>
    <style type="text/css">
        .style2
        {
            position: relative;
            top: 6px;
            left: 17px;
            height: 22px;
        }
        .style3
        {
            width: 394px;
        }
        .style1
        {
            position: relative;
            top: 4px;
            left: 19px;
        }
        .style4
        {
            position: relative;
            top: 4px;
            left: 83px;
            width: 78px;
        }
        .style5
        {
            position: relative;
            top: 50px;
            left: 4px;
            height: 26px;
            width: 77px;
        }
        .style6
        {
            position: relative;
            top: 8px;
            left: 9px;
        }
        .style7
        {
            position: relative;
            top: 6px;
            left: 5px;
        }
        .style8
        {
            width: 100%;
        }
        .style9
        {
            width: 443px;
        }
        </style>
</head>
<body>
    <form id="form1" runat="server">
    
        <asp:ScriptManager ID="ScriptManager1" runat="server" EnablePartialRendering="true" />
    <div class="style3">
    </div>

            <br />
            <br />
    <table class="style8">
        <tr>
            <td class="style9">

                &nbsp;</td>
            <td bgcolor="#CCFFCC" class="style9" style="border-style: groove">

    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                <asp:Label ID="Label5" runat="server" CssClass="style9" Font-Bold="True" 
                    Font-Size="X-Large" ForeColor="Maroon" Text="PRUEBA DE UPDATEPANEL"></asp:Label>

            </td>
            <td>
                &nbsp;</td>
            <td>
                &nbsp;</td>
        </tr>
        <tr>
            <td class="style9">

                &nbsp;</td>
            <td bgcolor="#CCFFCC" class="style9" style="border-style: groove">

    <asp:UpdatePanel ID="UpdatePanel1" runat="server" UpdateMode="Conditional">
        <ContentTemplate>
            <asp:Label ID="Label1" runat="server" Text="Cédula:"></asp:Label>
            &nbsp;
            <asp:TextBox ID="txtCedula" runat="server" CssClass="style1">txtCedula</asp:TextBox>
            <br />
            <br />
            <asp:Label ID="Label2" runat="server" Text="Nombre:"></asp:Label>
            <asp:TextBox ID="txtNombre" runat="server" CssClass="style2">txtNombre</asp:TextBox>
            <asp:Button ID="btnEnlistar" runat="server" CssClass="style4" Text="Enlistar" />
            <asp:Button ID="btnCancelar" runat="server" CssClass="style5" Text="Cancelar" />
            <br />
            <br />
            <asp:Label ID="Label3" runat="server" Text="Apellidos:"></asp:Label>
            <asp:TextBox ID="txtApellidos" runat="server" CssClass="style6">txtApellidos</asp:TextBox>
            <br />
            <br />
            <asp:Label ID="Label4" runat="server" Text="Dirección:"></asp:Label>
            <asp:TextBox ID="txtDireccion" runat="server" CssClass="style7">txtDireccion</asp:TextBox>
            <br />
            <br />
            <asp:Label runat="server" ID="timerLblUpdate1"> <%=DateTime.Now%> </asp:Label>
             <br />
             </ContentTemplate>
                    </asp:UpdatePanel>

            </td>
            <td>
                &nbsp;</td>
            <td>
                &nbsp;</td>
        </tr>
        <tr>
            <td class="style9">

                &nbsp;</td>
            <td bgcolor="#CCFFCC" class="style9" style="border-style: groove">

          <asp:UpdatePanel ID="UpdatePanel2" runat="server" UpdateMode="Conditional">
                <ContentTemplate>
                    <asp:GridView ID="PersonasGridView" runat="server" BackColor="#DEBA84" 
                        BorderColor="#DEBA84" BorderStyle="None" BorderWidth="1px" CellPadding="3" 
                        CellSpacing="2" Width="448px">
                        <RowStyle BackColor="#FFF7E7" ForeColor="#8C4510" />
                        <FooterStyle BackColor="#F7DFB5" ForeColor="#8C4510" />
                        <PagerStyle ForeColor="#8C4510" HorizontalAlign="Center" />
                        <SelectedRowStyle BackColor="#738A9C" Font-Bold="True" ForeColor="White" />
                        <HeaderStyle BackColor="#A55129" Font-Bold="True" ForeColor="White" />
                    </asp:GridView>
                    <br />
                    <asp:Label ID="timerLblUpdate2" runat="server"><%=DateTime.Now%></asp:Label>
                    <br />
                </ContentTemplate>
                <Triggers>
                    <asp:AsyncPostBackTrigger ControlID="btnEnlistar" EventName="Click" />
                </Triggers>
            </asp:UpdatePanel>
                <br />
                <br />
            </td>
            <td>
                &nbsp;</td>
            <td>
                &nbsp;</td>
        </tr>
    </table>
    </form>
</body>
</html>

