﻿<%@ Page Language="VB" %>
<%@ Import Namespace="System.Collections.Generic" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html  >
<head id="Head1" runat="server">
    <title>Agregue un nuevo Empleado:</title>
    <script runat="server">
        Private ListaEmpleados As List(Of Empleados)

        Protected Sub Page_Load()
            If Not IsPostBack Then
               ListaEmpleados = New List(Of Empleados)
               ListaEmpleados.Add(New Empleados(1, "Gómez Duarte", "Enrique"))
               ListaEmpleados.Add(New Empleados(2, "Gómez Duarte", " Carlos Enrique "))
                ViewState("Listado") =ListaEmpleados
            Else
               ListaEmpleados = CType(ViewState("Listado"), List(Of Empleados))
            End If
           
            EmpleadosGridView.DataSource =ListaEmpleados
            EmpleadosGridView.DataBind()
        End Sub

        Protected Sub InsertButton_Click(ByVal sender As Object, ByVal e As EventArgs)
            If String.IsNullOrEmpty(txtNombre.Text) Or _
               String.IsNullOrEmpty(txtApellidos.Text) Then Return

            Dim EmpleadosID As Integer = ListaEmpleados(ListaEmpleados.Count - 1).EmpleadosID + 1

            Dim Apellidos As String = Server.HtmlEncode(txtNombre.Text)
            Dim Nombre As String = Server.HtmlEncode(txtApellidos.Text)

            txtNombre.Text = String.Empty
            txtApellidos.Text = String.Empty

           ListaEmpleados.Add(New Empleados(EmpleadosID, Apellidos, Nombre))
            ViewState("Listado") =ListaEmpleados

            EmpleadosGridView.DataBind()
            EmpleadosGridView.PageIndex = EmpleadosGridView.PageCount
        End Sub

        Protected Sub CancelButton_Click(ByVal sender As Object, ByVal e As EventArgs)
            txtNombre.Text = String.Empty
            txtApellidos.Text = String.Empty
        End Sub
        <Serializable()> _
        Public Class Empleados
            Private _EmpleadosID As Integer
            Private _Apellidos As String
            Private _Nombre As String
            Public ReadOnly Property EmpleadosID() As Integer
                Get
                    Return _EmpleadosID
                End Get
            End Property

            Public ReadOnly Property Apellidos() As String
                Get
                    Return _Apellidos
                End Get
            End Property

            Public ReadOnly Property Nombre() As String
                Get
                    Return _Nombre
                End Get
            End Property

            Public Sub New(ByVal EmpleadosID As Integer, ByVal Apellidos As String, _
                                                                                        ByVal Nombre As String)
                _EmpleadosID = EmpleadosID
                _Apellidos = Apellidos
                _Nombre = Nombre
            End Sub
        End Class

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)

        End Sub
</script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        &nbsp;</div>
        <asp:ScriptManager ID="ScriptManager1" runat="server" EnablePartialRendering="true" />
        <table>
            <tr>
             <td style="height: 206px" valign="top">
                <asp:UpdatePanel ID="PanelInsertarActualizarEmpleados" runat="server" UpdateMode="Conditional">
                        <ContentTemplate>
                          <table cellpadding="2" border="0" style="background-color:#7C6F57">
                            <tr>
                              <td><asp:Label ID="NombreLabel" runat="server" AssociatedControlID="txtNombre" 
                                             Text="Nombre:" ForeColor="White" /></td>
                              <td><asp:TextBox runat="server" ID="txtNombre" /></td>
                            </tr>
                            <tr>
                              <td><asp:Label ID="ApellidosLabel" runat="server" AssociatedControlID="txtApellidos" 
                                             Text="Apellidos" ForeColor="White" /></td>
                              <td><asp:TextBox runat="server" ID="txtApellidos" /></td>
                            </tr>
                            <tr>
                              <td></td>
                              <td>
                  <asp:LinkButton ID="InsertButton" runat="server" Text="Agregar" OnClick="InsertButton_Click" ForeColor="White" />
               <asp:LinkButton ID="Cancelbutton" runat="server" Text="Cancelar" OnClick="CancelButton_Click" ForeColor="White" />
                              </td>
                            </tr>
                          </table>
                     <asp:Label runat="server" ID="InputTimeLabel"><%=DateTime.Now %></asp:Label>
                        </ContentTemplate>
                    </asp:UpdatePanel>
                </td>
                <td style="height: 206px" valign="top">
   
              <asp:UpdatePanel ID="EmpleadossUpdatePanel" runat="server" UpdateMode="Conditional">
                        <ContentTemplate>
     <asp:GridView ID="EmpleadosGridView" runat="server" BackColor="LightGoldenrodYellow" BorderColor="Tan"
               BorderWidth="1px" CellPadding="2" ForeColor="Black" GridLines="None" 
                                AutoGenerateColumns="False" Width="413px">
                                <FooterStyle BackColor="Tan" />
                                <SelectedRowStyle BackColor="DarkSlateBlue" ForeColor="GhostWhite" />
          <PagerStyle BackColor="PaleGoldenrod" ForeColor="DarkSlateBlue" HorizontalAlign="Center" />
                                <HeaderStyle BackColor="Tan" Font-Bold="True" />
                                <AlternatingRowStyle BackColor="PaleGoldenrod" />
                                <Columns>
                                    <asp:BoundField DataField="EmpleadosID" HeaderText="Empleados ID" />
                                    <asp:BoundField DataField="Apellidos" HeaderText="Apellidos" />
                                    <asp:BoundField DataField="Nombre" HeaderText="Nombre:" />
                                </Columns>
                                <PagerSettings PageButtonCount="5" />
                            </asp:GridView>
                        <asp:Label runat="server" ID="ListTimeLabel"><%=DateTime.Now %></asp:Label>
                        </ContentTemplate>
                        
                        <Triggers>
                            <asp:AsyncPostBackTrigger ControlID="InsertButton" EventName="Click" />
                        </Triggers>
                    </asp:UpdatePanel>
                </td>
            </tr>
        </table>
    </form>
</body>
</html>
