﻿<%@ Page Language="VB" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<script runat="server">
    Private Shared llavePaso As String = "s"
    Protected Sub OnNavigateHistory(ByVal sender As Object, _
                                  ByVal args As HistoryEventArgs)
     Dim stateString As String = args.State(llavePaso)
     Dim Paso As Integer = If(stateString IsNot Nothing, Integer.Parse(stateString), 0)
        MachineConfiguratorWizard.ActiveStepIndex = Paso
    End Sub

    Protected Sub OnActiveStepChanged(ByVal sender As Object, ByVal e As EventArgs)
        If Not ScriptManager1.IsNavigating AndAlso IsPostBack Then
            Dim index As Integer = MachineConfiguratorWizard.ActiveStepIndex
            ScriptManager1.AddHistoryPoint(llavePaso, index.ToString(), _
                                           "Paso " + (index + 1).ToString())
        End If
    End Sub
</script>
<html  >
<head id="Head1" runat="server">
    <title>Microsoft ASP.NET 3.5 Extensions: Managing History</title>
    <link href="../../include/qsstyle.css" type="text/css" rel="Stylesheet" />
</head>
<body>
    <div>
    <form id="form1" runat="server">
        <div>
            <asp:ScriptManager runat="server" ID="ScriptManager1"  
                                   OnNavigate="OnNavigateHistory" 
               EnableHistory="true" EnableSecureHistoryState="false" />
            <h2>
          Microsoft ASP.NET 3.5 Extensions: Agregando Puntos del Historial del 
          Explorador del lado del Servidor</h2>
            <p/>
            <div id="Div1" class="new">
                <p>Este ejemplo muestra:</p>
                <ol>
                <li>Como utilizar el control <code>ScriptManager</code> para 
                    configurar un conjunto de puntos de historial.</li>
                    <li>El control <code>ScriptManager</code>, las propiedades  
              <code>EnableHistory</code> y 
                    <code>EnableSecureHistoryState</code> y la propiedad
          <code>OnNavigate</code> para ejecutar el <code>el evento</code>navigate.
                    </li>
                    <li>Protegiendo el histórico con <code>IsNavigating</code>
                    </li>
                </ol>
         </div>
        <p>
        En este ejemplo, el <code>Wizard</code> control server provee nuestra propia 
        navegación, pero como cada paso es seleccionado, un punto histórico es 
        agregado. </p>
            <p>
        Al hacer esto, solamente un punto de historia es agregado si la pagina 
        no está siendo actualizada </p>
            <asp:UpdatePanel runat="server" ID="WizardPanel">
                <ContentTemplate>
                    <asp:Wizard ID="MachineConfiguratorWizard" runat="server" 
                      ActiveStepIndex="0" BackColor="#dddddd"
                        BorderWidth="10" CellPadding="10" CellSpacing="10" 
                        Height="200px" Width="700px"
                        FinishPreviousButtonText="<" StartNextButtonText=">" 
                        StepNextButtonText=">" StepPreviousButtonText="<"
                        FinishCompleteButtonText="<|>" 
                        OnActiveStepChanged="OnActiveStepChanged">
                        <WizardSteps>
                            <asp:WizardStep ID="Step1" runat="server" Title="Paso 1">
                                <h2>
                                    Paso 1</h2>
                                <br />
                            </asp:WizardStep>
                            <asp:WizardStep ID="Step2" runat="server" Title="Paso 2">
                                <h2>
                                    Paso 2</h2>
                                <br />
                            </asp:WizardStep>
                            <asp:WizardStep ID="Step3" runat="server" Title="Paso 3">
                                <h2>
                                    Paso 3</h2>
                                <br />
                            </asp:WizardStep>
                        </WizardSteps>
                        <StepStyle Font-Names="tahoma" Font-Size="Smaller" 
                         VerticalAlign="Top" />
                        <SideBarStyle Font-Size="Small" VerticalAlign="Top" 
                         BackColor="#FFFFC0" Font-Names="tahoma" />
                        <FinishPreviousButtonStyle BackColor="White" 
BorderColor="Black" BorderWidth="3px"
                            Font-Names="Tahoma" Font-Size="Medium" />
                        <NavigationButtonStyle BackColor="White" BorderColor="Black" 
                         BorderStyle="Solid"
                         BorderWidth="3px" Font-Names="Tahoma" Font-Size="Medium" />
                        <FinishCompleteButtonStyle Font-Names="Tahoma" Font-Size= "Medium" />
                    </asp:Wizard>
                </ContentTemplate>
            </asp:UpdatePanel>
    </div>
    </form>
</body>
</html>


