﻿<html >
<head id="Head1" runat="server">
    <title>Microsoft ASP.NET 3.5 Extensions</title>
    <link href="../../include/qsstyle.css" type="text/css" rel="Stylesheet" />

    <script type="text/javascript">
        function page_init() {
            Sys.Application.add_navigate(onStateChanged);
            var cb1 = $get('clientButton1');
            var cb2 = $get('clientButton2');
            var cb3 = $get('clientButton3');
            $addHandler(cb1, "click", clientClick);
            cb1.dispose = function() { $clearHandlers(cb1); }
            $addHandler(cb2, "click", clientClick);
            cb2.dispose = function() { $clearHandlers(cb2); }
            $addHandler(cb3, "click", clientClick);
            cb3.dispose = function() { $clearHandlers(cb3); }
        }

        function onStateChanged(sender, e) {
            // Cuando se navega, este evento es ejecutado.
            var val = parseInt(e.get_state().s || '0');
            Sys.Debug.trace("Navegando al Estado " + val);
            $get("div2").innerHTML = val;
        }

        function clientClick(e) {
            // Configura un punto de historia en el script del cliente.
            var val = parseInt(e.target.value);
        Sys.Application.addHistoryPoint({s: val}, "Botón Pulsado:" + val);
        Sys.Debug.trace("Punto del Histórico del Navegador agregado: " + val);
       }
    </script>
    <style type="text/css">
        #TraceConsole
        {
            height: 200px;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <div>
    <asp:ScriptManager runat="server" ID="ScriptManager1" 
                EnablePartialRendering="false" EnableHistory="true" />
            <script type="text/javascript">
                Sys.Application.add_init(page_init);
            </script>
            <h2>
       Microsoft ASP.NET 3.5 Extensions: Administrando el Histórico del
       Navegado con Script de Cliente</h2>
            <p />
            <div id="Div1" class="new">
                <p>
                    Este ejemplo muestra:</p>
                <ol>
         <li>El objeto <code>Sys.Application</code> el evento        
     <code>navigate</code> y el método <code>addHistoryPoint</code>.</li>
        <li>El método <code>addHistoryPoint</code> demuestra la adición de 
                 títulos en el ListBox.</li>
                </ol>
            </div>
            <p>
            </p>
            <h2>Ejemplo 1: administrando el Histórico del Navegador con Script 
                de Cliente</h2>
            <p>Este ejemplo incluye tres botones. La ejecución de cada botón 
               configura los <code>eventos</code>click
               de navegación (puntos históricos) mediante el objeto   <code>Sys.Application</code>.  
            </p>
            <p>El Script utilizado aquí, hace uso de la clase
            <code>Sys.Debug</code> para realizar el	volcado de información a 
             la traza de texto en la parte inferior de la página.
            </p>
            <p>Cuando se pulsa un botón y un punto de histórico es agregado,  
               se puede ver el histórico de entradas, por ejemplo, en
            "Paginas Recientes" de Internet Explorer, por ejemplo.
            </P>
            <p>Para ver el histórico en acción, siga los siguientes pasos:</p>

            <ol>
                <li>Pulse <b>1</b>.Ver la traza de salida .</li>
                <li>Pulse <b>3</b>.Ver la traza de salida .</li>
                <li>Pulse <b>2</b>.Ver la traza de salida .</li>
                <li>Pulse el botón de Atrás. Vea que la página es refrescada 
                    con los datos previos y 
                que la información y que puede localizar la información que 
                muestra este.</li>
            </ol>
            <div id="div2" class="box"></div><p></p>
                <input type="button" id="clientButton1" value="1" />
                <input type="button" id="clientButton2" value="2" />
                <input type="button" id="clientButton3" value="3" />
            <br /><br />
            <textarea id="TraceConsole" cols="40"></textarea>
        </div>
    </form>
</body>
</html>
